<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__sysclk__fll__funcs" kind="group">
    <compoundname>group_sysclk_fll_funcs</compoundname>
    <title>Functions</title>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__sysclk__fll__funcs_1gad9d9c36d022475746375bddaba2b2065" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__sysclk__returns_1gad6699a184e2e3c01433251b0981558f3">cy_en_sysclk_status_t</ref></type>
        <definition>cy_en_sysclk_status_t Cy_SysClk_FllConfigure</definition>
        <argsstring>(uint32_t inputFreq, uint32_t outputFreq, cy_en_fll_pll_output_mode_t outputMode)</argsstring>
        <name>Cy_SysClk_FllConfigure</name>
        <param>
          <type>uint32_t</type>
          <declname>inputFreq</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>outputFreq</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__sysclk__fll__enums_1ga777e08424e26c9cd8c2602b2114e716b">cy_en_fll_pll_output_mode_t</ref></type>
          <declname>outputMode</declname>
        </param>
        <briefdescription>
<para>Configures the FLL, for best accuracy optimization. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>inputFreq</parametername>
</parameternamelist>
<parameterdescription>
<para>frequency of input source, in Hz</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>outputFreq</parametername>
</parameternamelist>
<parameterdescription>
<para>Desired FLL output frequency, in Hz. Allowable range is 24 MHz to 100 MHz. In all cases, FLL_OUTPUT_DIV must be set; the output divide by 2 option is required.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>outputMode</parametername>
</parameternamelist>
<parameterdescription>
<para><ref kindref="member" refid="group__group__sysclk__fll__enums_1ga777e08424e26c9cd8c2602b2114e716b">cy_en_fll_pll_output_mode_t</ref> If output mode is bypass, then the output frequency equals the input source frequency regardless of the frequency parameter values.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Error / status code: <linebreak />
CY_SYSCLK_SUCCESS - FLL successfully configured <linebreak />
CY_SYSCLK_INVALID_STATE - FLL not configured because it is enabled <linebreak />
CY_SYSCLK_BAD_PARAM - desired output frequency is out of valid range</para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Call this function after changing the FLL input frequency, for example if &lt;a href="group__group__sysclk__path__src__funcs.html#group__group__sysclk__path__src__funcs_1ga517f603266062d0013947ea950ed5b60"&gt;Cy_SysClk_ClkPathSetSource()&lt;/a&gt; is called.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Do not call this function when the FLL is enabled. If it is called, then this function returns with an CY_SYSCLK_INVALID_STATE return value and no register updates.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Call &lt;a href="group__group__system__config__system__functions.html#group__group__system__config__system__functions_1gae0c36a9591fe6e9c45ecb21a794f0f0f"&gt;SystemCoreClockUpdate&lt;/a&gt; after this function calling if it affects the CLK_HF0 frequency.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Call &lt;a href="group__group__syslib__functions.html#group__group__syslib__functions_1ga8b897f8554957f9393f645d5ab1106c9"&gt;Cy_SysLib_SetWaitStates&lt;/a&gt; before calling this function if the FLL is the source of CLK_HF0 and the FLL frequency is increasing.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Call &lt;a href="group__group__syslib__functions.html#group__group__syslib__functions_1ga8b897f8554957f9393f645d5ab1106c9"&gt;Cy_SysLib_SetWaitStates&lt;/a&gt; after calling this function if the FLL is the source of CLK_HF0 and the FLL frequency is decreasing.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;On PSoC 64 devices the configuration on the PRA driver will be reflected after &lt;a href="group__group__sysclk__fll__funcs.html#group__group__sysclk__fll__funcs_1ga5a008909d3f50d85fb8d8c9f56ed8886"&gt;Cy_SysClk_FllEnable&lt;/a&gt; call. Any call to &lt;a href="group__group__sysclk__fll__funcs.html#group__group__sysclk__fll__funcs_1ga8e8ceae09a6a3e825c3ab9cea5561eed"&gt;Cy_SysClk_FllGetConfiguration&lt;/a&gt; before calling &lt;a href="group__group__sysclk__fll__funcs.html#group__group__sysclk__fll__funcs_1ga5a008909d3f50d85fb8d8c9f56ed8886"&gt;Cy_SysClk_FllEnable&lt;/a&gt; returns old configuration values.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />FLL<sp />needs<sp />to<sp />source<sp />HFCLK0,<sp />which<sp />must<sp />operate<sp />at<sp />100<sp />MHz.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />The<sp />IMO<sp />sources<sp />the<sp />FLL<sp />at<sp />8MHz.<sp />Startup<sp />time<sp />is<sp />not<sp />an<sp />issue</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />and<sp />manual<sp />configuration<sp />of<sp />the<sp />FLL<sp />is<sp />not<sp />needed.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />FLL<sp />source<sp />(path<sp />0<sp />mux)<sp />to<sp />be<sp />the<sp />IMO<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<ref kindref="member" refid="group__group__sysclk__path__src__funcs_1ga517f603266062d0013947ea950ed5b60">Cy_SysClk_ClkPathSetSource</ref>(0UL,<sp /><ref kindref="member" refid="group__group__sysclk__path__src__enums_1gga8ddaf9023a02dee0d1f9a5629d6ccfe6a01c7cbab413a99daa41d2fb7a0340955">CY_SYSCLK_CLKPATH_IN_IMO</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Auto-configure<sp />the<sp />FLL<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__sysclk__returns_1ggad6699a184e2e3c01433251b0981558f3a1563f761f963757b339ff05eb5a690ec">CY_SYSCLK_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__sysclk__fll__funcs_1gad9d9c36d022475746375bddaba2b2065">Cy_SysClk_FllConfigure</ref>(<ref kindref="member" refid="group__group__sysclk__macros_1ga9b98d83b0a60b378966d56f7636d85a6">CY_SYSCLK_IMO_FREQ</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Input<sp />clock<sp />=<sp />8<sp />MHz<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />100000000UL,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Output<sp />clock<sp />=<sp />100<sp />MHz<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__fll__enums_1gga777e08424e26c9cd8c2602b2114e716baf9198d7cbbee5db8e8c48375125aee74">CY_SYSCLK_FLLPLL_OUTPUT_OUTPUT</ref>))<sp /><sp /></highlight><highlight class="comment">/*<sp />Bypass<sp />Mux<sp />to<sp />FLL<sp />Output<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />the<sp />FLL<sp />with<sp />2000<sp />microsecond<sp />timeout<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__sysclk__returns_1ggad6699a184e2e3c01433251b0981558f3a1563f761f963757b339ff05eb5a690ec">CY_SYSCLK_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__sysclk__fll__funcs_1ga5a008909d3f50d85fb8d8c9f56ed8886">Cy_SysClk_FllEnable</ref>(2000UL))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />HFCLK0<sp />source<sp />to<sp />clock<sp />path<sp />0<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<ref kindref="member" refid="group__group__sysclk__clk__hf__funcs_1ga4d090b2e9716939fe4689fac77b05679">Cy_SysClk_ClkHfSetSource</ref>(0UL,<sp /><ref kindref="member" refid="group__group__sysclk__clk__hf__enums_1ggabac2d6b9124a00860dcd781a922788d6ab67e691f04cd3aecb2a4cbf8bbd5b787">CY_SYSCLK_CLKHF_IN_CLKPATH0</ref>);</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="787" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_sysclk.c" bodystart="665" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" line="943" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__sysclk__fll__funcs_1ga0e2e272b670cc52ab984291afae6a1fa" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__sysclk__returns_1gad6699a184e2e3c01433251b0981558f3">cy_en_sysclk_status_t</ref></type>
        <definition>cy_en_sysclk_status_t Cy_SysClk_FllManualConfigure</definition>
        <argsstring>(const cy_stc_fll_manual_config_t *config)</argsstring>
        <name>Cy_SysClk_FllManualConfigure</name>
        <param>
          <type>const <ref kindref="compound" refid="structcy__stc__fll__manual__config__t">cy_stc_fll_manual_config_t</ref> *</type>
          <declname>config</declname>
        </param>
        <briefdescription>
<para>Manually configures the FLL based on user inputs. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>config</parametername>
</parameternamelist>
<parameterdescription>
<para><ref kindref="compound" refid="structcy__stc__fll__manual__config__t">cy_stc_fll_manual_config_t</ref></para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Error / status code: <linebreak />
CY_SYSCLK_SUCCESS - FLL successfully configured <linebreak />
CY_SYSCLK_INVALID_STATE - FLL not configured because it is enabled CY_SYSCLK_INVALID_STATE - ECO already enabled For the PSoC 64 devices there are possible situations when function returns the PRA error status code. This is because for PSoC 64 devices the function uses the PRA driver to change the protected registers. Refer to <ref kindref="member" refid="group__group__pra__enums_1ga60be13e12e82986f8c0d6c6a6d4f12c5">cy_en_pra_status_t</ref> for more details.</para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Call this function after changing the FLL input frequency, for example if &lt;a href="group__group__sysclk__path__src__funcs.html#group__group__sysclk__path__src__funcs_1ga517f603266062d0013947ea950ed5b60"&gt;Cy_SysClk_ClkPathSetSource()&lt;/a&gt; is called.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Do not call this function when the FLL is enabled. If it is called, then this function returns immediately with an CY_SYSCLK_INVALID_STATE return value and no register updates.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Call &lt;a href="group__group__system__config__system__functions.html#group__group__system__config__system__functions_1gae0c36a9591fe6e9c45ecb21a794f0f0f"&gt;SystemCoreClockUpdate&lt;/a&gt; after this function calling if it affects the CLK_HF0 frequency.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Call &lt;a href="group__group__syslib__functions.html#group__group__syslib__functions_1ga8b897f8554957f9393f645d5ab1106c9"&gt;Cy_SysLib_SetWaitStates&lt;/a&gt; before calling this function if the FLL is the source of CLK_HF0 and the FLL frequency is increasing.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Call &lt;a href="group__group__syslib__functions.html#group__group__syslib__functions_1ga8b897f8554957f9393f645d5ab1106c9"&gt;Cy_SysLib_SetWaitStates&lt;/a&gt; after calling this function if the FLL is the source of CLK_HF0 and the FLL frequency is decreasing.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;On PSoC 64 devices the configuration on the PRA driver will be reflected after &lt;a href="group__group__sysclk__fll__funcs.html#group__group__sysclk__fll__funcs_1ga5a008909d3f50d85fb8d8c9f56ed8886"&gt;Cy_SysClk_FllEnable&lt;/a&gt; call. Any call to &lt;a href="group__group__sysclk__fll__funcs.html#group__group__sysclk__fll__funcs_1ga8e8ceae09a6a3e825c3ab9cea5561eed"&gt;Cy_SysClk_FllGetConfiguration&lt;/a&gt; before calling &lt;a href="group__group__sysclk__fll__funcs.html#group__group__sysclk__fll__funcs_1ga5a008909d3f50d85fb8d8c9f56ed8886"&gt;Cy_SysClk_FllEnable&lt;/a&gt; returns old configuration values.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />FLL<sp />needs<sp />to<sp />source<sp />HFCLK0,<sp />which<sp />must<sp />operate<sp />at<sp />100<sp />MHz.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />The<sp />IMO<sp />sources<sp />the<sp />FLL<sp />at<sp />8MHz.<sp />The<sp />characteristics<sp />of<sp />the</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />FLL<sp />lock<sp />parameters<sp />are<sp />already<sp />known<sp />and<sp />the<sp />startup<sp />time</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />for<sp />the<sp />FLL<sp />configuration<sp />must<sp />be<sp />minimized.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Refer<sp />to<sp />the<sp />TRM<sp />for<sp />the<sp />full<sp />set<sp />of<sp />equations<sp />used<sp />to<sp />calculate<sp />the<sp />parameters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__fll__manual__config__t">cy_stc_fll_manual_config_t</ref><sp />fllConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*.fllMult<sp />=*/</highlight><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />1725UL,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Multiplier<sp />for<sp />CCO<sp />frequency<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*.refDiv<sp />=*/</highlight><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(uint16_t)69u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Reference<sp />clock<sp />divider<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*.ccoRange<sp />=*/</highlight><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__fll__enums_1ggac8760ee841ca24255c9a4fee494b79aaa6c50c6395080bcf0cc45094a6eaf22b4">CY_SYSCLK_FLL_CCO_RANGE4</ref>,<sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Target<sp />CCO<sp />range<sp />of<sp />200<sp />(100*2)<sp />MHz<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*.enableOutputDiv<sp />=*/</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Output<sp />divider<sp />enabled<sp />(divide<sp />by<sp />2)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*.lockTolerance<sp />=*/</highlight><highlight class="normal"><sp /><sp /><sp />33u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Lock<sp />tolerance<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*.igain<sp />=*/</highlight><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />7u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />FLL<sp />loop<sp />filter<sp />integral<sp />gain<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*.pgain<sp />=*/</highlight><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />5u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />FLL<sp />loop<sp />filter<sp />proportional<sp />gain<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*.settlingCount<sp />=*/</highlight><highlight class="normal"><sp /><sp /><sp />8u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wait<sp />count<sp />before<sp />loop<sp />measurement<sp />restarts<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*.outputMode<sp />=*/</highlight><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__fll__enums_1gga777e08424e26c9cd8c2602b2114e716baf9198d7cbbee5db8e8c48375125aee74">CY_SYSCLK_FLLPLL_OUTPUT_OUTPUT</ref>,</highlight><highlight class="comment">/*<sp />Bypass<sp />Mux<sp />to<sp />FLL<sp />Output<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*.cco_Freq<sp />=*/</highlight><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />355u<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />CCO<sp />frequency<sp />code<sp />(HW<sp />controlled<sp />during<sp />lock)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />FLL<sp />source<sp />(path<sp />0<sp />mux)<sp />to<sp />be<sp />the<sp />IMO<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<ref kindref="member" refid="group__group__sysclk__path__src__funcs_1ga517f603266062d0013947ea950ed5b60">Cy_SysClk_ClkPathSetSource</ref>(0UL,<sp /><ref kindref="member" refid="group__group__sysclk__path__src__enums_1gga8ddaf9023a02dee0d1f9a5629d6ccfe6a01c7cbab413a99daa41d2fb7a0340955">CY_SYSCLK_CLKPATH_IN_IMO</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />the<sp />FLL<sp />lock<sp />using<sp />pre-calculated<sp />values<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__sysclk__returns_1ggad6699a184e2e3c01433251b0981558f3a1563f761f963757b339ff05eb5a690ec">CY_SYSCLK_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__sysclk__fll__funcs_1ga0e2e272b670cc52ab984291afae6a1fa">Cy_SysClk_FllManualConfigure</ref>(&amp;fllConfig))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />the<sp />FLL<sp />with<sp />2000<sp />microsecond<sp />timeout<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__sysclk__returns_1ggad6699a184e2e3c01433251b0981558f3a1563f761f963757b339ff05eb5a690ec">CY_SYSCLK_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__sysclk__fll__funcs_1ga5a008909d3f50d85fb8d8c9f56ed8886">Cy_SysClk_FllEnable</ref>(2000UL))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />HFCLK0<sp />source<sp />to<sp />clock<sp />path<sp />0<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<ref kindref="member" refid="group__group__sysclk__clk__hf__funcs_1ga4d090b2e9716939fe4689fac77b05679">Cy_SysClk_ClkHfSetSource</ref>(0UL,<sp /><ref kindref="member" refid="group__group__sysclk__clk__hf__enums_1ggabac2d6b9124a00860dcd781a922788d6ab67e691f04cd3aecb2a4cbf8bbd5b787">CY_SYSCLK_CLKHF_IN_CLKPATH0</ref>);</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="886" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_sysclk.c" bodystart="835" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" line="944" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__sysclk__fll__funcs_1ga8e8ceae09a6a3e825c3ab9cea5561eed" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void Cy_SysClk_FllGetConfiguration</definition>
        <argsstring>(cy_stc_fll_manual_config_t *config)</argsstring>
        <name>Cy_SysClk_FllGetConfiguration</name>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__fll__manual__config__t">cy_stc_fll_manual_config_t</ref> *</type>
          <declname>config</declname>
        </param>
        <briefdescription>
<para>Reports the FLL configuration settings. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>config</parametername>
</parameternamelist>
<parameterdescription>
<para><ref kindref="compound" refid="structcy__stc__fll__manual__config__t">cy_stc_fll_manual_config_t</ref></para></parameterdescription>
</parameteritem>
</parameterlist>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;On PSoC 64 devices the configuration on the PRA driver will be reflected after &lt;a href="group__group__sysclk__fll__funcs.html#group__group__sysclk__fll__funcs_1ga5a008909d3f50d85fb8d8c9f56ed8886"&gt;Cy_SysClk_FllEnable&lt;/a&gt; call. Any call to &lt;a href="group__group__sysclk__fll__funcs.html#group__group__sysclk__fll__funcs_1ga8e8ceae09a6a3e825c3ab9cea5561eed"&gt;Cy_SysClk_FllGetConfiguration&lt;/a&gt; before calling &lt;a href="group__group__sysclk__fll__funcs.html#group__group__sysclk__fll__funcs_1ga5a008909d3f50d85fb8d8c9f56ed8886"&gt;Cy_SysClk_FllEnable&lt;/a&gt; returns old configuration values.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />The<sp />calculated<sp />FLL<sp />parameters<sp />need<sp />to<sp />be<sp />checked.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__fll__manual__config__t">cy_stc_fll_manual_config_t</ref><sp />fllConfig;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Auto-configure<sp />the<sp />FLL<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__sysclk__returns_1ggad6699a184e2e3c01433251b0981558f3a1563f761f963757b339ff05eb5a690ec">CY_SYSCLK_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__sysclk__fll__funcs_1gad9d9c36d022475746375bddaba2b2065">Cy_SysClk_FllConfigure</ref>(8000000UL,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Input<sp />clock<sp />=<sp />8<sp />MHz<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />100000000UL,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Output<sp />clock<sp />=<sp />100<sp />MHz<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__fll__enums_1gga777e08424e26c9cd8c2602b2114e716baf9198d7cbbee5db8e8c48375125aee74">CY_SYSCLK_FLLPLL_OUTPUT_OUTPUT</ref>))<sp /><sp /></highlight><highlight class="comment">/*<sp />Bypass<sp />Mux<sp />to<sp />FLL<sp />Output<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Retrieve<sp />the<sp />calculated<sp />parameters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__fll__funcs_1ga8e8ceae09a6a3e825c3ab9cea5561eed">Cy_SysClk_FllGetConfiguration</ref>(&amp;fllConfig);</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="926" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_sysclk.c" bodystart="905" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" line="945" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__sysclk__fll__funcs_1ga5a008909d3f50d85fb8d8c9f56ed8886" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__sysclk__returns_1gad6699a184e2e3c01433251b0981558f3">cy_en_sysclk_status_t</ref></type>
        <definition>cy_en_sysclk_status_t Cy_SysClk_FllEnable</definition>
        <argsstring>(uint32_t timeoutus)</argsstring>
        <name>Cy_SysClk_FllEnable</name>
        <param>
          <type>uint32_t</type>
          <declname>timeoutus</declname>
        </param>
        <briefdescription>
<para>Enables the FLL. </para>        </briefdescription>
        <detaileddescription>
<para>The FLL should be configured before calling this function.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>timeoutus</parametername>
</parameternamelist>
<parameterdescription>
<para>Amount of time in micro seconds to wait for FLL to lock. If lock doesn't occur, the FLL is stopped. To avoid waiting for lock, set this to 0 and manually check for lock using <ref kindref="member" refid="group__group__sysclk__fll__funcs_1ga219934b4636182f2bcaaac613b79a66f">Cy_SysClk_FllLocked</ref>.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Error / status code: <linebreak />
CY_SYSCLK_SUCCESS - FLL successfully enabled <linebreak />
CY_SYSCLK_TIMEOUT - Timeout waiting for FLL lock CY_SYSCLK_INVALID_STATE - ECO already enabled For the PSoC 64 devices there are possible situations when function returns the PRA error status code. This is because for PSoC 64 devices the function uses the PRA driver to change the protected registers. Refer to <ref kindref="member" refid="group__group__pra__enums_1ga60be13e12e82986f8c0d6c6a6d4f12c5">cy_en_pra_status_t</ref> for more details.</para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;While waiting for the FLL to lock, the FLL bypass mode is set to &lt;a href="group__group__sysclk__fll__enums.html#group__group__sysclk__fll__enums_1gga777e08424e26c9cd8c2602b2114e716baf2893197c53d0101be01ef926a33528b"&gt;CY_SYSCLK_FLLPLL_OUTPUT_INPUT&lt;/a&gt;. After the FLL is locked, the FLL bypass mdoe is then set to &lt;a href="group__group__sysclk__fll__enums.html#group__group__sysclk__fll__enums_1gga777e08424e26c9cd8c2602b2114e716baf9198d7cbbee5db8e8c48375125aee74"&gt;CY_SYSCLK_FLLPLL_OUTPUT_OUTPUT&lt;/a&gt;.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Call &lt;a href="group__group__system__config__system__functions.html#group__group__system__config__system__functions_1gae0c36a9591fe6e9c45ecb21a794f0f0f"&gt;SystemCoreClockUpdate&lt;/a&gt; after calling this function if it affects the CLK_HF0 frequency.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Call &lt;a href="group__group__syslib__functions.html#group__group__syslib__functions_1ga8b897f8554957f9393f645d5ab1106c9"&gt;Cy_SysLib_SetWaitStates&lt;/a&gt; before calling this function if the FLL is the source of CLK_HF0 and the CLK_HF0 frequency is increasing.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />FLL<sp />is<sp />configured<sp />and<sp />needs<sp />to<sp />be<sp />enabled<sp />within<sp />2<sp />ms<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CLKPATH0<sp />(0UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />clkPathFreq<sp />=<sp />0UL;<sp /></highlight><highlight class="comment">/*<sp />Variable<sp />to<sp />store<sp />the<sp />Clock<sp />Path<sp />output<sp />frequency<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />the<sp />FLL<sp />with<sp />a<sp />timeout<sp />of<sp />2000<sp />microseconds<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__sysclk__returns_1ggad6699a184e2e3c01433251b0981558f3a1563f761f963757b339ff05eb5a690ec">CY_SYSCLK_SUCCESS</ref><sp />==<sp /><ref kindref="member" refid="group__group__sysclk__fll__funcs_1ga5a008909d3f50d85fb8d8c9f56ed8886">Cy_SysClk_FllEnable</ref>(2000UL))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />clkPathFreq<sp />=<sp /><ref kindref="member" refid="group__group__sysclk__path__src__funcs_1ga54c618c89782d227fb8f292d1dc15625">Cy_SysClk_ClkPathGetFrequency</ref>(CLKPATH0);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Now<sp />clkPathFreq<sp />contains<sp />an<sp />actual<sp />FLL<sp />frequency<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="1011" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_sysclk.c" bodystart="963" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" line="946" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__sysclk__fll__funcs_1ga219934b4636182f2bcaaac613b79a66f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>__STATIC_INLINE bool</type>
        <definition>__STATIC_INLINE bool Cy_SysClk_FllLocked</definition>
        <argsstring>(void)</argsstring>
        <name>Cy_SysClk_FllLocked</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Reports whether the FLL is locked first time during FLL starting. </para>        </briefdescription>
        <detaileddescription>
<para>Intended to be used with <ref kindref="member" refid="group__group__sysclk__fll__funcs_1ga5a008909d3f50d85fb8d8c9f56ed8886">Cy_SysClk_FllEnable</ref> with zero timeout.</para><para><simplesect kind="return"><para>false = not locked <linebreak />
true = locked</para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The unlock occurrence may appear during FLL normal operation, so this function is not recommended to check the FLL normal operation stability.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />FLL<sp />is<sp />configured<sp />and<sp />needs<sp />to<sp />be<sp />enabled<sp />in<sp />a<sp />non-blocking<sp />way<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />the<sp />FLL<sp />without<sp />timeout<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<ref kindref="member" refid="group__group__sysclk__fll__funcs_1ga5a008909d3f50d85fb8d8c9f56ed8886">Cy_SysClk_FllEnable</ref>(0UL);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />the<sp />status<sp />of<sp />the<sp />lock<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">(!<ref kindref="member" refid="group__group__sysclk__fll__funcs_1ga219934b4636182f2bcaaac613b79a66f">Cy_SysClk_FllLocked</ref>())</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Perform<sp />other<sp />actions<sp />while<sp />the<sp />FLL<sp />is<sp />locking<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />FLL<sp />Locked.<sp />Proceed<sp />with<sp />further<sp />configuration<sp />*/</highlight><highlight class="normal" /></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="994" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" bodystart="991" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" line="947" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__sysclk__fll__funcs_1ga005ceb7b4ba7267ad2eaf7b2f3bce687" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>__STATIC_INLINE bool</type>
        <definition>__STATIC_INLINE bool Cy_SysClk_FllIsEnabled</definition>
        <argsstring>(void)</argsstring>
        <name>Cy_SysClk_FllIsEnabled</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Reports whether or not the FLL is enabled. </para>        </briefdescription>
        <detaileddescription>
<para><simplesect kind="return"><para>false = disabled <linebreak />
true = enabled</para></simplesect>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />FLL<sp />failed<sp />to<sp />enable<sp />and<sp />must<sp />be<sp />reconfigured.<sp />Or<sp />the<sp />FLL<sp />is<sp />no</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />longer<sp />used<sp />and<sp />hence<sp />needs<sp />to<sp />be<sp />disabled.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__sysclk__fll__funcs_1ga005ceb7b4ba7267ad2eaf7b2f3bce687">Cy_SysClk_FllIsEnabled</ref>())</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__sysclk__returns_1ggad6699a184e2e3c01433251b0981558f3a1563f761f963757b339ff05eb5a690ec">CY_SYSCLK_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__sysclk__fll__funcs_1gaadcbb5bfff956a7eb51a52d419b85f3d">Cy_SysClk_FllDisable</ref>())</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />clocks<sp />that<sp />relied<sp />on<sp />the<sp />FLL<sp />will<sp />now<sp />run<sp />off<sp />of<sp />the<sp />clock<sp />that</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp />was<sp />used<sp />to<sp />source<sp />the<sp />FLL<sp />(e.g.<sp />IMO<sp />or<sp />ECO).<sp />*/</highlight><highlight class="normal" /></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="969" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" bodystart="966" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" line="948" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__sysclk__fll__funcs_1gaadcbb5bfff956a7eb51a52d419b85f3d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>__STATIC_INLINE <ref kindref="member" refid="group__group__sysclk__returns_1gad6699a184e2e3c01433251b0981558f3">cy_en_sysclk_status_t</ref></type>
        <definition>__STATIC_INLINE cy_en_sysclk_status_t Cy_SysClk_FllDisable</definition>
        <argsstring>(void)</argsstring>
        <name>Cy_SysClk_FllDisable</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Disables the FLL and the CCO. </para>        </briefdescription>
        <detaileddescription>
<para><simplesect kind="return"><para><ref kindref="member" refid="group__group__sysclk__returns_1gad6699a184e2e3c01433251b0981558f3">cy_en_sysclk_status_t</ref> CY_SYSCLK_INVALID_STATE - ECO already enabled For the PSoC 64 devices there are possible situations when function returns the PRA error status code. This is because for PSoC 64 devices the function uses the PRA driver to change the protected registers. Refer to <ref kindref="member" refid="group__group__pra__enums_1ga60be13e12e82986f8c0d6c6a6d4f12c5">cy_en_pra_status_t</ref> for more details.</para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Call &lt;a href="group__group__system__config__system__functions.html#group__group__system__config__system__functions_1gae0c36a9591fe6e9c45ecb21a794f0f0f"&gt;SystemCoreClockUpdate&lt;/a&gt; after this function calling if it affects the CLK_HF0 frequency.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Call &lt;a href="group__group__syslib__functions.html#group__group__syslib__functions_1ga8b897f8554957f9393f645d5ab1106c9"&gt;Cy_SysLib_SetWaitStates&lt;/a&gt; after calling this function if the FLL is the source of CLK_HF0 and the CLK_HF0 frequency is decreasing.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />FLL<sp />failed<sp />to<sp />enable<sp />and<sp />must<sp />be<sp />reconfigured.<sp />Or<sp />the<sp />FLL<sp />is<sp />no</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />longer<sp />used<sp />and<sp />hence<sp />needs<sp />to<sp />be<sp />disabled.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__sysclk__fll__funcs_1ga005ceb7b4ba7267ad2eaf7b2f3bce687">Cy_SysClk_FllIsEnabled</ref>())</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__sysclk__returns_1ggad6699a184e2e3c01433251b0981558f3a1563f761f963757b339ff05eb5a690ec">CY_SYSCLK_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__sysclk__fll__funcs_1gaadcbb5bfff956a7eb51a52d419b85f3d">Cy_SysClk_FllDisable</ref>())</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />clocks<sp />that<sp />relied<sp />on<sp />the<sp />FLL<sp />will<sp />now<sp />run<sp />off<sp />of<sp />the<sp />clock<sp />that</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp />was<sp />used<sp />to<sp />source<sp />the<sp />FLL<sp />(e.g.<sp />IMO<sp />or<sp />ECO).<sp />*/</highlight><highlight class="normal" /></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="1033" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" bodystart="1022" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" line="949" />
      </memberdef>
      </sectiondef>
    <briefdescription>
    </briefdescription>
    <detaileddescription>
    </detaileddescription>
  </compounddef>
</doxygen>